VERSION 5.00
Begin VB.UserControl AutoFillNormalCombo 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "AutoFillNormalCombo.ctx":0000
   Begin VB.ComboBox cboCombo 
      Height          =   315
      Left            =   330
      TabIndex        =   0
      Top             =   180
      Width           =   3015
   End
End
Attribute VB_Name = "AutoFillNormalCombo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public ComboProperties As ComboBox
Private booLimitToList As Boolean

Event BeforeKeyPress()
Event AfterKeyPress()

Property Get LimitToList() As Boolean
    LimitToList = booLimitToList
End Property

Property Let LimitToList(booLimit As Boolean)
    booLimitToList = booLimit
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    booLimitToList = PropBag.ReadProperty("LimitToList", True)
    
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("LimitToList", booLimitToList, True)

End Sub

Private Sub cboCombo_KeyDown(KeyCode As Integer, Shift As Integer)
    
RaiseEvent BeforeKeyPress
    
    Select Case KeyCode
        Case 65 - 90        'a-z and A-Z
            UserControl.cboCombo.Locked = True
        Case 48 - 57        '0-9
            UserControl.cboCombo.Locked = True
        Case 188            ',
            UserControl.cboCombo.Locked = True
        Case 190            '.
            UserControl.cboCombo.Locked = True
        Case 223            '`
            UserControl.cboCombo.Locked = True
        Case 220            '\
            UserControl.cboCombo.Locked = True
    End Select
    
End Sub

Private Sub cboCombo_KeyPress(KeyAscii As Integer)
Dim strNonSelectedText As String

    If KeyAscii = 8 Then
        UserControl.cboCombo.Locked = False
        Exit Sub
    End If
    
    strNonSelectedText = Left(UserControl.cboCombo.Text, UserControl.cboCombo.SelStart)
    If WasKeyUsed(strNonSelectedText & Chr(KeyAscii)) = True Then
        KeyAscii = 0
    Else
        If LimitToList = True Then
            KeyAscii = 0
        End If
    End If
    
RaiseEvent AfterKeyPress

End Sub

Private Sub UserControl_ExitFocus()

    If UserControl.cboCombo.Text <> "" Then
        UserControl.cboCombo.Text = GetProperCase(UserControl.cboCombo.Text)
    End If

End Sub

Private Function GetProperCase(strText As String) As String
Dim lngRow As Long

    For lngRow = 0 To UserControl.cboCombo.ListCount
        If UCase$(UserControl.cboCombo.List(lngRow)) = UCase$(strText) Then
            GetProperCase = UserControl.cboCombo.List(lngRow)
            Exit Function
        End If
    Next lngRow
    GetProperCase = strText

End Function

Private Sub UserControl_Initialize()
    Set ComboProperties = UserControl.cboCombo
End Sub

Private Sub UserControl_Resize()
    
    With UserControl.cboCombo
        .Top = 0
        .Left = 0
        .Width = UserControl.Width
        UserControl.Height = .Height
    End With
    
End Sub

Private Function WasKeyUsed(strTypedPrevious As String) As Boolean
Dim lngRow As Long
Dim intLen As Integer
Dim strToAdd As String
    
    intLen = Len(strTypedPrevious)
    
    For lngRow = 0 To UserControl.cboCombo.ListCount
        
        If Left(UCase$(UserControl.cboCombo.List(lngRow)), intLen) = UCase$(strTypedPrevious) Then
            strToAdd = Mid(UserControl.cboCombo.List(lngRow), intLen + 1)
            With UserControl.cboCombo
                .Locked = False
                .Text = strTypedPrevious & strToAdd
                .SelStart = intLen
                .SelLength = Len(strToAdd)
            End With
            WasKeyUsed = True
            Exit Function
        End If
        
    Next lngRow
    
End Function
